#include "d_vars.sp"


public Jump_OnPluginStart()
{
	g_cvJumpBoost = CreateConVar(
	"sm_Perks_doublejump_boost", "250.0",
	"The amount of vertical boost to apply to double jumps.",
	FCVAR_PLUGIN|FCVAR_NOTIFY
	);
	
	g_cvJumpMax = CreateConVar(
	"sm_Perks_doublejump_max", "1",
	"The maximum number of re-jumps allowed while already jumping.",
	FCVAR_PLUGIN|FCVAR_NOTIFY
	);
	
	HookConVarChange(g_cvJumpBoost,		convar_ChangeBoost);
	
	HookConVarChange(g_cvJumpMax,		convar_ChangeMax);
	
	
	g_flBoost		= GetConVarFloat(g_cvJumpBoost);
	g_iJumpMax		= GetConVarInt(g_cvJumpMax);
}


public convar_ChangeBoost(Handle:convar, const String:oldVal[], const String:newVal[]) {
	g_flBoost = StringToFloat(newVal)
}

public convar_ChangeEnable(Handle:convar, const String:oldVal[], const String:newVal[]) {
	if (StringToInt(newVal) >= 1) {
		g_bDoubleJump = true
	} else {
		g_bDoubleJump = false
	}
}

public convar_ChangeMax(Handle:convar, const String:oldVal[], const String:newVal[]) {
	g_iJumpMax = StringToInt(newVal)
}

public OnGameFrame() {
	if (g_bDoubleJump) {							
		for (new i = 1; i <= MaxClients; i++) {		
			if (
			IsClientInGame(i) &&				
			IsPlayerAlive(i)					
			) {
				DoubleJump(i)						
			}
		}
	}
}

stock DoubleJump(const any:client) {
	new health = GetEntProp(client, Prop_Send, "m_iHealth");
	if(health <= 45)
	{
		
		if(Item_ID[client] == 7)
		{
			new
			fCurFlags	= GetEntityFlags(client),		
			fCurButtons	= GetClientButtons(client);		
			
			if (g_fLastFlags[client] & FL_ONGROUND) {		
				if (
				!(fCurFlags & FL_ONGROUND) &&			
				!(g_fLastButtons[client] & IN_JUMP) &&	
				fCurButtons & IN_JUMP					
				) {
					OriginalJump(client)					
				}
			} else if (										
			fCurFlags & FL_ONGROUND						
			) {
				Landed(client)							
			} else if (										
			!(g_fLastButtons[client] & IN_JUMP) &&		
			fCurButtons & IN_JUMP						
			) {
				ReJump(client);			
			}
			
			g_fLastFlags[client]	= fCurFlags;				
			g_fLastButtons[client]	= fCurButtons;			
		}
	}
}

stock OriginalJump(const any:client) {
	g_iJumps[client]++	
}

stock Landed(const any:client) {
	g_iJumps[client] = 0	
}

stock ReJump(const any:client) {
	if ( 1 <= g_iJumps[client] <= g_iJumpMax) {						
		g_iJumps[client]++											
		decl Float:vVel[3]
		GetEntPropVector(client, Prop_Data, "m_vecVelocity", vVel)	
		
		vVel[2] = g_flBoost
		TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vVel)		
	}
}