#include "s-perks/_functions.sp"
#include "s-perks/_data.sp"

public CoreLoad()
{
	HookLoaders();
	c_GameCredits = RegClientCookie("PerkDatabase", "PerkDatabase", CookieAccess_Private);
	c_GamePerks = RegClientCookie("PerkDatabase_prk", "PerkDatabase_prk", CookieAccess_Private);
	CreditsMax = CreateConVar("Perks_Max_Credits", "100", "max of credits allowed (0: No limit)");
	CreditsKill = CreateConVar("Perks_Kills_Credits", "1", "credits for kill");
	CreditsSave = CreateConVar("Perks_Can_Credits_Save", "1", "enable or disable that credits can be saved");
	if(GetConVarBool(CreditsSave))
		for(new client = 1; client <= MaxClients; client++)
	{
		if(IsClientInGame(client))
		{
			if(AreClientCookiesCached(client))
			{
				OnClientCookiesCached(client);
			}
		}
	}
}


public OnPluginEnd()
{
	if(!GetConVarBool(CreditsSave))
		return;
	
	for(new client = 1; client <= MaxClients; client++)
	{
		if(IsClientInGame(client))
		{
			OnClientDisconnect(client);
		}
	}
}

public OnClientCookiesCached(client)
{
	if(!GetConVarBool(CreditsSave))
		return;
	
	new String:CreditsString[12];
	GetClientCookie(client, c_GameCredits, CreditsString, sizeof(CreditsString));
	g_iCredits[client]  = StringToInt(CreditsString);
	new String:InvString[2000];
	GetClientCookie(client, c_GamePerks, InvString, sizeof(InvString));
	Perk_ID_In_Inv[client]  = StringToInt(InvString);
}

public OnClientDisconnect(client)
{
	if(!GetConVarBool(CreditsSave))
	{
		g_iCredits[client] = 0;
		Perk_ID_In_Inv[client] = 0;
		return;
	}
	
	if(AreClientCookiesCached(client))
	{
		new String:CreditsString[12];
		Format(CreditsString, sizeof(CreditsString), "%i", g_iCredits[client]);
		SetClientCookie(client, c_GameCredits, CreditsString);
		new String:InvString[2000];
		Format(InvString, sizeof(InvString), "%i", Perk_ID_In_Inv[client]);
		SetClientCookie(client, c_GamePerks, InvString);
	}
}

public Action:PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new client_me = GetClientOfUserId(GetEventInt(event, "userid"));
	KillTimer(tcredits[client_me]);
	if (!attacker)
		return;
	
	if (attacker == client)
		return;
	if (GetClientTeam(attacker) == CS_TEAM_CT)
	{	
		
		
		g_iCredits[attacker] += GetConVarInt(CreditsKill);
		
		if (g_iCredits[attacker] < GetConVarInt(CreditsMax))
		{
			PrintToChat(attacker, "\x04[Perks] \x05Your Reputation: %i (+%i)", g_iCredits[attacker],GetConVarInt(CreditsKill));
		}
		else
		{
			g_iCredits[attacker] = GetConVarInt(CreditsMax);
			PrintToChat(attacker, "\x04[Perks] \x05Your Reputation: %i (Maximum allowed)", g_iCredits[attacker]);
		}
	}
}

public Action:Cmd_Perks(client, args)
{
	if( IsPlayerAlive( client ) )
	{
		
		
		PrintToChat(client,"\x04 [Perks]\x05 Menu loading...!");
		perkmenu(client);
		
	}
	else
	{
		
	}
}

public Action:perkmenu(client)
{
	
	new Handle:menu = CreateMenu(Perk_Info);
	SetMenuTitle(menu, "Perk Menu \n Reputation: %i",g_iCredits[client]);
	AddMenuItem(menu, "m1", "Equipment Perks");
	AddMenuItem(menu, "m2", "Ability Perks");
	if(GetUserAdmin(client) != INVALID_ADMIN_ID)
	{
		AddMenuItem(menu, "m3", "Donor Perks");
	}
	else
	{
		AddMenuItem(menu, "m3", "Donor Perks");
	}
	AddMenuItem(menu, "m4", "Information");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	
}

public Action:E_Perks(client)
{
	
	new Handle:menu = CreateMenu(Perk_Info);
	
	SetMenuTitle(menu, "Equipment Perks");
	if(g_iCredits[client] >= 1)
	{
		AddMenuItem(menu, "I1", "Gain 1 Decoy[1-Rep]");
	}
	else
	{
		AddMenuItem(menu, "", "Gain 1 Decoy[1-Rep]",ITEMDRAW_DISABLED);
	}
	if(g_iCredits[client] >= 1)
	{
		AddMenuItem(menu, "I2", "Gain 1 Flashbang[1-Rep]");
	}
	else
	{
		AddMenuItem(menu, "", "Gain 1 Flashbang[1-Rep]",ITEMDRAW_DISABLED);
	}
	if(g_iCredits[client] >= 3)
	{
		AddMenuItem(menu, "I3", "Gain 1 Molotov[3-Rep]");
	}
	else
	{
		AddMenuItem(menu, "", "Gain 1 Molotov[3-Rep]",ITEMDRAW_DISABLED);
	}
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	
}
public Action:Inf_Perks(client)
{
	
	new Handle:menu = CreateMenu(Perk_Info);
	
	SetMenuTitle(menu, "Information Perks");
	AddMenuItem(menu, "", "Reputation is earned by getting a kill on CT or trying to last a long time on T.");
	AddMenuItem(menu, "", "All Reputation is saved upon leaving the server.");
	AddMenuItem(menu, "", "Perks that you buy last a life time untill you buy another perk.");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	
}

public Perk_Info(Handle:menu, MenuAction:action, param1, param2)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			decl String:info[32];
			GetMenuItem(menu, param2, info, sizeof(info));
			if (StrEqual(info, "m1"))
			{
				E_Perks(param1);
			}
			if (StrEqual(info, "m4"))
			{
				Inf_Perks(param1);
			}
			
			if (StrEqual(info, "I1"))
			{
				if (GetClientTeam(param1) == CS_TEAM_T)
				{
					g_iCredits[param1] -= 1;
					Perk_ID_In_Inv[param1] = 1;
					Perk_ID[param1] = 1;
				}
				else
				{
					PrintToChat(param1, "\x04[Perks] \x05This Perk Is Not Avalible For\x02 CT!");
				}
			}
			if (StrEqual(info, "I2"))
			{
				if (GetClientTeam(param1) == CS_TEAM_T)
				{
					g_iCredits[param1] -= 1;
					Perk_ID_In_Inv[param1] = 2;
					Perk_ID[param1] = 2;
				}
				else
				{
					PrintToChat(param1, "\x04[Perks] \x05This Perk Is Not Avalible For\x02 CT!");
				}
			}
			if (StrEqual(info, "I3"))
			{
				if (GetClientTeam(param1) == CS_TEAM_T)
				{
					g_iCredits[param1] -= 1;
					Perk_ID_In_Inv[param1] = 3;
					Perk_ID[param1] = 3;
				}
				else
				{
					PrintToChat(param1, "\x04[Perks] \x05This Perk Is Not Avalible For\x02 CT!");
				}
			}
			else
			{
				PrintToServer("Client %d selected %s", param1, info);
			}
		}
	}
}

public Event_PlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{	
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (!client || !IsClientInGame(client))
		return;
	//new victimId = GetEventInt(event, "userid");
	//new attackerId = GetEventInt(event, "attacker");
	
	//new victim = GetClientOfUserId(victimId);
	//new attacker = GetClientOfUserId(attackerId);
	new health = GetEntProp(client, Prop_Send, "m_iHealth");
	
	if (GetClientTeam(client) == CS_TEAM_CT)
	{	
		
	}
	if (GetClientTeam(client) == CS_TEAM_T)
	{	
		
		if(health <= 45)
		{
			if(Perk_ID[client] == 1)
			{	
				PrintToChat(client, "\x04[Perks] \x05-[Perk Activated]You got a \x02Decoy!");
				GivePlayerItem(client, "weapon_decoy");
				Perk_ID[client] = 0;
			}
			if(Perk_ID[client] == 2)
			{	
				PrintToChat(client, "\x04[Perks] \x05-[Perk Activated]You got a \x02Flashbang!");
				GivePlayerItem(client, "weapon_flashbang");
				Perk_ID[client] = 0;
			}
			if(Perk_ID[client] == 3)
			{	
				PrintToChat(client, "\x04[Perks] \x05-[Perk Activated]You got a \x02Molotov!");
				GivePlayerItem(client, "weapon_molotov");
				Perk_ID[client] = 0;
			}
		}
		
	}
}

public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{	
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (!client || !IsClientInGame(client))
		return;
	Perk_ID[client] = Perk_ID_In_Inv[client];
	PrintToChat(client, "\x04[Perks] \x05Please type \x02<!p> \x05to access the perks menu");
	if (GetClientTeam(client) == CS_TEAM_T)
	{	
		tcredits[client] = CreateTimer(100.0, tcred, client);
	}
}

public Action:tcred(Handle:timer, any:client)
{
	g_iCredits[client] += 4;
	PrintToChat(client, "\x04[Perks] \x05You gained \x02<+4> \x05reputation!");
	KillTimer(tcredits[client]);
}
