#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include "ShadowLibs/srank_mysql.sp"
new Handle:g_PointsPerKill;
new Handle:g_PointsBonus;
public OnPluginStart()
{
	RunDataBaseSetUp();
	RegConsoleCmd("sm_stats",Cmd_Stats);
	HookEvent("player_death", OnPlayerDeath);
	g_PointsPerKill = CreateConVar("srank_PointsPerKill","3","Amount of points given to a player per kill.");
	g_PointsBonus = CreateConVar("srank_PointsBonus","3","Amount of points to be given on top of 'PointsPerKill' when player has done a special event etc 'Headshots'.");
	AutoExecConfig(true,"Srank");
}

public Action:Cmd_Stats(client,args)
{
	if(IsClientInGame(client))
	{
		SrankStatsMenu(client);
	}
	return Plugin_Handled;
}

SrankStatsMenu(client)
{
	new Handle:panel = CreatePanel(INVALID_HANDLE);
	new String:KillsFormat[150];
	new String:DeathsFormat[150];
	new String:PointsFormat[150];
	new String:HeadshotsFormat[150];
	new String:NameFormat[150];
	Format(KillsFormat,sizeof(KillsFormat),"Kills - [%i]", PlayerKills[client]);
	Format(HeadshotsFormat,sizeof(HeadshotsFormat),"Headshots - [%i]", PlayerHeadShots[client]);
	Format(DeathsFormat,sizeof(DeathsFormat),"Deaths - [%i]", PlayerDeaths[client]);
	Format(PointsFormat,sizeof(PointsFormat),"Points - [%i]", PlayerPoints[client]);
	Format(NameFormat,sizeof(NameFormat),"%s - [Stats]", PlayerName[client]);
	SetPanelTitle(panel, NameFormat);
	DrawPanelText(panel,KillsFormat);
	DrawPanelText(panel,HeadshotsFormat);
	DrawPanelText(panel,DeathsFormat);
	DrawPanelText(panel,PointsFormat);
	DrawPanelItem(panel,"Close");
	SendPanelToClient(panel,client, StatsHandle,100);
}

public StatsHandle(Handle:menu, MenuAction:action, param1, param2)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			decl String:info[32];
			GetMenuItem(menu, param2, info, sizeof(info));
			
			if (StrEqual(info, "Close"))
			{
				PrintToChat(param1,"\x03 [SRank] \x02 Stats panel has been closed.")
			}	
			
		}
	}
}

public OnClientPutInServer(client)
{
	SrankLoad(client);
}
public OnClientDisconnect(client)
{
	SrankSave(client);	
}

public SrankSave(client)
{
	if (!IsClientInGame(client))
		return;
	
	new String:query[400], String:auth[400];
	GetClientAuthString(client, auth, sizeof(auth));
	GetClientName(client, PlayerName[client],sizeof(PlayerName));
	Format(query, sizeof(query), "UPDATE srank SET name = %d,kills = %d,deaths = %d,headshots = %d, points = %d WHERE steamid = '%s'",PlayerName[client],PlayerKills[client],PlayerDeaths[client],PlayerHeadShots[client],PlayerPoints[client],auth);
	SQL_TQuery(hDatabase, Srank_Save, query, client);
} 

public SrankLoad(client)
{
	new String:query[400], String:auth[400];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT * FROM srank WHERE steamid = '%s'", auth);
	
	SQL_TQuery(hDatabase, Srank_Load, query, client);
}

public OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new victimId = GetEventInt(event, "userid")
	new attackerId = GetEventInt(event, "attacker")
	new bool:headshot = GetEventBool(event, "headshot")
	new victim = GetClientOfUserId(victimId)
	new attacker = GetClientOfUserId(attackerId)
	new String:VictimName[100]
	new String:AttackerName[100]
	GetClientName(victim, VictimName,sizeof(VictimName));
	GetClientName(attacker, AttackerName,sizeof(AttackerName));
	PlayerDeaths[victim]++;
	PrintToChat(victim,"\x03 [SRank] \x07 %s \x02 you have been killed by \x07 %s",VictimName,AttackerName);
	if(headshot)
	{
		PlayerHeadShots[attacker]++;
		PlayerPoints[attacker] += GetConVarInt(g_PointsPerKill) + GetConVarInt(g_PointsBonus);
		PrintToChat(attacker,"\x03 [SRank] \x02 You have earned \x07 %i \x02 points for getting a headshot!",GetConVarInt(g_PointsPerKill) + GetConVarInt(g_PointsBonus));
	}
	else
	{
		PlayerKills[attacker]++;
		PlayerPoints[attacker] += GetConVarInt(g_PointsPerKill);
		PrintToChat(attacker,"\x03[SRank] \x02 You have earned \x07%i \x02 points for getting a kill!",GetConVarInt(g_PointsPerKill));
	}
	SrankSave(attacker);
	SrankSave(victim);
}
	